;**********************************************************************
;*                                                                    *
;*     Rotina para determinar desenhar uma elipse dados dois          *
;*                       dimetros conjugados                         *
;*                                                                    *
;**********************************************************************

;**********************************************************************
;*                    Portugal - Lisboa, Agosto, 2007                 *
;*                                                                    *
;*     Escrito por Lus Miguel Cotrim Mateus - lmmateus@fa.utl.pt     *
;*                                                                    *
;*     Faculdade de Arquitectura da Universidade Tcnica de Lisboa    *
;*                                                                    *
;**********************************************************************

;translaco

(defun trs (tx ty x y)
  (setq xt (+ x tx))
  (setq yt (+ y ty))

  	(setq pt (list xt yt))
)

; interseco de uma recta (x,y).(0,0) com uma circunferncia de raio R de centro na origem (0,0)
(defun RxC (x y Raio)

(setq R1 (distance (list 0 0) (list x y)))

(setq Sf (/ Raio R1))

(setq x1 (* Sf x))
(setq y1 (* Sf y))

	(setq P1 (list x1 y1))

(setq x2 (- x1))
(setq y2 (- y1))

	(setq P2 (list x2 y2))
  
)

; elipse

(defun c:eli ()
  (setq pC (getpoint "\nSeleccione o centro da elipse:"))
  (setq pD (getpoint "\nSeleccione um extremo de dimetro conjugado:"))
  (setq pE (getpoint "\nSeleccione um extremo do outro dimetro conjugado:"))

  (command "osmode" "0")
  
(setq xC (car pC))
(setq yC (cadr pC))

(setq xD (car pD))
(setq yD (cadr pD))

(setq xE (car pE))
(setq yE (cadr pE))


; 1 passo - determinao do centro da circunferncia afim, o ponto O

(setq xO (+ xC yD (- yC) (- xE xC)))
(setq yO (+ yC (- xD) xC (- yE yC)))

;(setq xO (+ xC yD (- yC) xE (- xC)))
;(setq yO (+ yC (- xD) xC yE (- yC)))

(setq pO (list xO yO))
  
; 2 passo - determinao de um ponto I sobre o eixo da afinidade

(setq xI (+ xE xD (- xC)))
(setq yI (+ yE yD (- yC)))

(setq ptI (list xI yI))
  
; 3 passo - determinao do ponto Q mdio do segmento |CO|

(setq xQ (/ (+ xO xC) 2))
(setq yQ (/ (+ yO yC) 2))

(setq pQ (list xQ yQ))  

; 4 passo - conduo da perpendicular a C.O por pQ

(setq xN (+ xQ yC (- yO)))
(setq yN (+ yQ xO (- xC)))

(setq pN (list xN yN))
  
; 5 passo - detrminao determinao de pM, ponto de interseco de N.Q com o eixo da afinidade

(setq pM (inters pN pQ ptI pE nil))  
  
; 6 passo - determinao de R, distncia |MC|

(setq R (distance pM pC)) 

; 7 passo - interseco do eixo da afinidade com o crculo de centro M e raio R, pontos pt1 e pt2

(setq xM (car pM))
(setq yM (cadr pM))
  
(trs (- xM) (- yM) xI yI)
     (setq xI1 xt)
     (setq yI1 yt)

  
(RxC xI1 yI1 R)
     (setq pt11 P1)
     (setq pt21 P2)


(trs xM yM (car pt11) (cadr pt11))
     (setq xpt1 xt)
     (setq ypt1 yt)
  (setq pt1 (list xpt1 ypt1))
     ;(setq pt1 pt)
     

(trs xM yM (car pt21) (cadr pt21))
     (setq xpt2 xt)
     (setq ypt2 yt)
  (setq pt2 (list xpt2 ypt2))
     ;(setq pt2 pt)

; 8 passo - interseco das rectas pt1.O e pt2.O com o crculo de centro O e raio |OE|, pontos PtA e ptB

(trs (- xO) (- yO) (car pt1) (cadr pt1))
     (setq xpt12 xt)
     (setq ypt12 yt)
  (setq pt12 (list xpt12 ypt12))
     ;(setq pt12 pt)
  
(trs (- xO) (- yO) (car pt2) (cadr pt2))
     (setq xpt22 xt)
     (setq ypt22 yt)
  (setq pt22 (list xpt22 ypt22))
     ;(setq pt22 pt)

  
(setq R (distance pO pE))

(RxC xpt12 ypt12 R)
     (setq ptA1 P1)

(RxC xpt22 ypt22 R)
     (setq ptB1 P1)

(trs xO yO (car ptA1) (cadr ptA1))
     (setq xptA xt)
     (setq yptA yt)
  (setq ptA (list xptA yptA))
     ;(setq ptA pt)

(trs xO yO (car ptB1) (cadr ptB1))
     (setq xptB xt)
     (setq yptB yt)
  (setq ptB (list xptB yptB))
     ;(setq ptB pt)
  
; 9 passo - rectas paralelas ao eixo da afinidade passantes por ptA e ptB

(setq xC1 (+ (car ptA) (- xO) xC))
(setq yC1 (+ (cadr ptA) yC (- yO)))
     (setq ptC1 (list xC1 yC1))

(setq xC2 (+ (car ptB) (- xO) xC))
(setq yC2 (+ (cadr ptB) yC (- yO)))
     (setq ptC2 (list xC2 yC2))

; 10 passo - determinao dos pontos afins de ptA e ptB, pontos ptA- e ptB-

(setq ptA- (inters ptA ptC1 pt1 pC nil))

(setq ptB- (inters ptB ptC2 pt2 pC nil))

; 11 passo - criao da entidade elipse

(setq l-0 (cons 0 "ELLIPSE"))
(setq l-100 (cons 100 "AcDbEntity"))
(setq l-100- (cons 100 "AcDbEllipse"))

  
(setq l-10 (list 10 xC yC 0.0))

(setq eixo2 (distance ptA- pC))
(setq eixo1 (distance ptB- pC))

(if
  (< eixo2 eixo1)
  (and (setq maior eixo1) (setq menor eixo2))
  (and (setq maior eixo2) (setq menor eixo1))
  ) 

(setq l-40 (cons 40 (/ menor maior)))

  
(if
  (< eixo2 eixo1)
  (setq axisend ptB-)
  (setq axisend ptA-)
  )

(setq x_rel (- (car axisend) xC))
(setq y_rel (- (cadr axisend) yC))

(setq l-11 (list 11 x_rel y_rel 0.0))

  
(setq lista (list l-0 l-100 l-100- l-10 l-11 l-40))

(entmake lista)

(command "osmode" "3")

  )


