;**********************************************************************
;*                                                                    *
;*     Rotina para determinar o ngulo que fazem duas fachadas        *
;*     aproximadamente planas atravs de uma foto de esquina          *
;*     tirada com o eixo da objectiva na horizontal                   *
;*                                                                    *
;**********************************************************************

;**********************************************************************
;*                    Portugal - Lisboa, Dezembro, 2007               *
;*                                                                    *
;*     Escrito por Lus Miguel Cotrim Mateus - lmmateus@fa.utl.pt     *
;*                                                                    *
;*     Faculdade de Arquitectura da Universidade Tcnica de Lisboa    *
;*                                                                    *
;**********************************************************************

; distncia "dist" de um ponto "Pt1" a uma recta "Pt1.Pt2"
(defun dptr (Pt1 Pt2 Pt3)
	(setq x1 (car Pt1))
  	(setq y1 (cadr Pt1))
  	(setq x2 (car Pt2))
  	(setq y2 (cadr Pt2))
  	(setq x3 (car Pt3))
  	(setq y3 (cadr Pt3))
	(setq x4 (+ x1 (- y2 y3)))
  	(setq y4 (+ y1 (- x3 x2)))
  	(setq Pt4 (list x4 y4))
  (setq Pin (inters Pt4 Pt1 Pt2 Pt3 nil))
  (setq dist (distance Pt1 Pin))
)
; interseco de uma recta (w,z).(w3,0) com uma circunferncia de raio R de centro na origem (0,0)
(defun RxC (w z w3 R)
	(setq a (+ 1 (* (/ (- w3 w) z) (/ (- w3 w) z))))
  	(setq b (* -2 w3 (/ (- w3 w) z)))
  	(setq c (- (* w3 w3) (* R R)))
;                    ponto 1
	(setq Yu1 (/ (+ (- b) (sqrt (- (* b b) (* 4 a c)))) (* 2 a)))
  	(setq Xu1 (- w3 (* Yu1 (/ (- w3 w) z))))
  	(setq Pu1 (list Xu1 Yu1))
;                    ponto 2
	(setq Yu2 (/ (- (- b) (sqrt (- (* b b) (* 4 a c)))) (* 2 a)))
  	(setq Xu2 (- w3 (* Yu2 (/ (- w3 w) z))))
  	(setq Pu2 (list Xu2 Yu2)) 
)
; determinante em coordenadas homogneas de trs pontos sendo um deles a origem (x1,y1,1) (x2,y2,1) (0,0,1)
(defun detO (x1 y1 x2 y2)
  (setq dt- (abs (* (+ (* x1 y2) (- (* x2 y1)))))) 
)
; seleco das medidas
(defun sel (ent)
  (setq i_l (car ent))
  (setq l_e (entget i_l))
  (setq lP1 (assoc 10 l_e))
  (setq lP2 (assoc 11 l_e))
  (setq x1 (cadr lP1))
  (setq y1 (caddr lP1))
  (setq x2 (cadr lP2))
  (setq y2 (caddr lP2))
  (setq P1 (list x1 y1))
  (setq P2 (list x2 y2))
)
; definio dos pontos mdios das fachadas na foto
(defun pts_cruz (Phr1 Phr2 P_r1 P_r2) 
  (setq Pi_1 (inters Phr1 P_r1 Phr2 P_r2 nil))
  (setq Pi_2 (inters Phr1 P_r2 Phr2 P_r1 nil))

  (setq d1_ (+ (distance Pi_1 Phr1) (distance Pi_1 Phr2)  (distance Pi_1 P_r1)  (distance Pi_1 P_r2)))
  (setq d2_ (+ (distance Pi_2 Phr1) (distance Pi_2 Phr2)  (distance Pi_2 P_r1)  (distance Pi_2 P_r2)))

  (if
    (> d1_ d2_)
	 (setq Pmr_ Pi_2)
	 (setq Pmr_ Pi_1)
    )
)
; define o centro C e raio R das circunferncias auxiliares
(defun cen_rai (D_ D_- -d_ -d_-)
        (setq XC (/
		    (* -d_ -d_- (- D_ D_-))
		    (- (* D_ -d_-) (* D_- -d_))
		    )
	      )
	(setq C (list XC 0))
	(setq R (abs
		     (/
		       (* D_ D_- (- -d_- -d_))
		       (- (* D_ -d_-) (* D_- -d_))
		       )
		     )
		   )
)
; desenho das linhas
(defun linhas (1Pl_ 1Pl_- 2Pl_ 2Pl_-)
  
(detO (car 1Pl_) (cadr 1Pl_) (car 1Pl_-) (cadr 1Pl_-))
(setq dt11- dt-)
  
(detO (car 1Pl_) (cadr 1Pl_) (car 2Pl_-) (cadr 2Pl_-))
(setq dt12- dt-)

(detO (car 2Pl_) (cadr 2Pl_) (car 2Pl_-) (cadr 2Pl_-))
(setq dt22- dt-)

(detO (car 2Pl_) (cadr 2Pl_) (car 1Pl_-) (cadr 1Pl_-))
(setq dt21- dt-)

(setq dt-ref (min dt11- dt12- dt22- dt21-))

  (if (= dt-ref dt11-) (setq Pf1 1Pl_)
    (progn
      (if (= dt-ref dt12-) (setq Pf1 1Pl_) (setq Pf1 2Pl_))))

(setq XPf1 (car Pf1))
(setq YPf1 (cadr Pf1))

(setq XPf1- (+ XPf1 Bx))
(setq YPf1- (+ YPf1 By))

(setq lista2 (list 11 XPf1- YPf1-))
(setq lista (list lista0 lista1 lista2))
(entmake lista)
)


;rotina para desenhar o angulo entre duas fachadas verticais com uma aresta comum
(defun c:planta ()
;                    distancias de controlo
(print "")
  (setq ent (entsel "Na foto, selecione a aresta comum s duas fachadas:"))
  (sel ent)
  (setq Phr1 P1)
  (setq Phr2 P2)
  (setq hr (distance Phr1 Phr2))
(print "")
  (setq ent (entsel "Na foto, selecione uma vertical  esquerda da aresta comum:"))
  (sel ent)
  (setq Per1 P1)
  (setq Per2 P2)
(print "")
  (setq ent (entsel "Na foto, selecione uma vertical  direita da aresta comum:"))
  (sel ent)
  (setq Pdr1 P1)
  (setq Pdr2 P2)
(print "")
  (setq ent (entsel "Seleccione num dos alados a altura de referncia:"))
  (sel ent)
  (setq Ph1 P1)
  (setq Ph2 P2)
  (setq h (distance Ph1 Ph2))
(print "")
  (setq ent (entsel "Seleccione a largura da fachada esquerda:"))
  (sel ent)
  (setq Pe1 P1)
  (setq Pe2 P2)
  (setq D1 (distance Pe1 Pe2))
(print "")
  (setq ent (entsel "Seleccione a largura da fachada direita:"))
  (sel ent)
  (setq Pd1 P1)
  (setq Pd2 P2)
  (setq D2 (distance Pd1 Pd2))
(print "")
  
(dptr Per1 Phr1 Phr2)
  (setq -d1r dist)
  
(dptr Pdr1 Phr1 Phr2)
  (setq -d2r dist)

  (setq D1- (/ D1 2))
  (setq D2- (/ D2 2))

  (setq -d1 (* -d1r (/ h hr)))
  (setq -d2 (* -d2r (/ h hr)))
;                   pontos de cruzamento na fachada esquerda, foto
  (pts_cruz Phr1 Phr2 Per1 Per2)
  (setq Pmre Pmr_)	 	 
  (dptr Pmre Phr1 Phr2)
  (setq -d1- (* dist (/ h hr)))
;                   pontos de cruzamento na fachada direita, foto
  (pts_cruz Phr1 Phr2 Pdr1 Pdr2)
  (setq Pmrd Pmr_)
  (dptr Pmrd Phr1 Phr2)
  (setq -d2- (* dist (/ h hr)))
;                    vrtice da planta
  (setq BB (getpoint "\nvrtice da planta:"))
    (setq sc-de 1)
    (setq sc-para 0)
	(setq BB (trans BB sc-de sc-para))
  (setq Bx (car BB))
  (setq By (cadr BB))
;                    listas para a criao da entidade linha
  (setq lista0 (cons 0 "LINE"))
  (setq lista1 (list 10 Bx By))
;                    centro C1 da cisrcunferncia 1 de raio R1
(cen_rai D1 D1- -d1 -d1-)
  (setq C1 (list  (-(car C)) 0))
  (setq R1 R)
;                    centro C2 da circunferncia 2 de raio R2
(cen_rai D2 D2- -d2 -d2-)
  (setq C2 C)
  (setq R2 R)   
;                    determinao dos pontos I1 e I2 de interseco das circunferncias de raio R1 e R2, com centros em C1 e C2, respectivamente
;                    operao equivalente  determinao da posio do Observador; na prtica s  necessrio I2
(setq Xal (- (car C1) R1))
(setq Xal- (+ (car C1) R1))
(setq Xbe (- (car C2) R2))
(setq Xbe- (+ (car C2) R2))

(setq Xi (/ (- (* Xal Xal-) (* Xbe Xbe-)) (+ Xal- Xal (- Xbe-) (- Xbe))))
(setq Yi1 (sqrt (* (- Xal- Xi) (- Xi Xal))))
(setq Yi2 (- Yi1))

(setq I2 (list Xi Yi2))
;                    determinao das posies possveis para os pontos da planta (lado esquerdo)
;                    sobre as linhas [I2 P1 ] e [I2 P1-]
(setq x1 (- -d1))
(RxC Xi Yi2 x1 D1)
  (setq 1Pl1 Pu1)
  (setq 2Pl1 Pu2)
(setq x1- (- -d1-)) 
(RxC Xi Yi2 x1- D1-)
  (setq 1Pl1- Pu1)
  (setq 2Pl1- Pu2)
;                    determinao da linha do lado esquerdo
(linhas 1Pl1 1Pl1- 2Pl1 2Pl1-)
;                   determinao das posies possveis para os pontos da planta (lado direito)
;                   sobre as linhas [I2 P2 ] e [I2 P2-]
(setq x2 -d2)
(RxC Xi Yi2 x2 D2)
  (setq 1Pl2 Pu1)
  (setq 2Pl2 Pu2)
(setq x2- -d2-) 
(RxC Xi Yi2 x2- D2-)
  (setq 1Pl2- Pu1)
  (setq 2Pl2- Pu2)
;                   determinao da linha do lado direito
(linhas 1Pl2 1Pl2- 2Pl2 2Pl2-)
;fim
(print)
)







